;ASC2COM
;CP/M Plus fuer CPC und PCW/JOYCE
;(c) 1992 Wolfgang Traeber und CPC International

        title   ASCII-Datei zu COM-Datei umwandeln
        subttl  ASC2COM.ASM
        list    nocond
        list    text
;
true    equ     -1     ;Ja-Wert
pcw     equ     not true   ;bei CPC6128 auf NOT TRUE
cpc6128 equ     not pcw
boot    equ     0      ;Warmstart
bdos    equ     5      ;BDOS-Vektor
printf  equ     9      ;BDOS-Funktion Print String
conio   equ     6      ;BDOS-Funktion Dir Con I/O
cinput  equ     0fdh   ;Console Input
conout  equ     2      ;BDOS-Funktion Con Output
tpa     equ     0100h  ;TPA-Adresse
BELL    equ     7      ;Piepser
LF      equ     00ah   ;Line Feed
EOF     equ     01ah   ;Dateiende
ESC     equ     01bh   ;Escapezeichen
backf   equ     '-'    ;zurueckblaettern
forwrdf equ     '+'    ;vorwaertsblaettern
exitf   equ     '0'    ;Programm beenden
        if      pcw
pmax    equ     30     ;maximale Anzahl Zeilen
        else
pmax    equ     24     ;maximale Anzahl Zeilen
        endif
;
        org     tpa
;
   call    clear       ;Bildschirm loeschen
   ld      hl,text     ;HL <- Textbereich
   ld      b,0         ;B  <- Zeilenzaehler
;
msgout:                ;CYCLE
   ld      a,(hl)      ;A  <- Zeichen
   inc     hl          ;HL <- naechstes Zeichen
   cp      EOF         ;WHEN Dateiende
   jr      eq,progend  ;BREAK
   call    chrout      ;Zeichen ausgeben
   cp      LF          ;IF Line Feed
   call    eq,newline  ;Zeilenende verarbeiten
   jr      msgout      ;END CYCLE
;
progend:               ;Programm beenden
   jp      boot        ;Warmstart
;
chrout:                ;Zeichen ausgeben
   push    af          ;AF sichern
   push    bc          ;BC sichern
   push    hl          ;HL sichern
   ld      c,conout    ;C  <- Print Character
   ld      e,a         ;E  <- Zeichen
   call    bdos        ;Zeichen ausgeben
   pop     hl          ;HL zurueckholen
   pop     bc          ;BC zurueckholen
   pop     af          ;AF zurueckholen
   ret
;
newline:               ;Zeilenende verarbeiten
   inc     b           ;B  <- Zeilenzaehler erh.
   ld      a,b         ;A  <- Zeilenzaehler
   cp      pmax        ;IF Bildschirm voll
   call    eq,newpage  ;Blaettern
   ret
;
newpage:               ;Blaettern
   ld      de,contmsg  ;DE <- Blaetterkommando
   call    prstr       ;ausgeben
np1:
   push    bc          ;BC sichern
   push    hl          ;HL sichern
   ld      c,conio     ;C  <- Direct Console I/O
   ld      e,cinput    ;E  <- Console Input
   call    bdos        ;Auf Taste warten
   pop     hl          ;HL zurueckladen
   pop     bc          ;BC zurueckladen
   cp      exitf       ;IF Blattern beenden
   jp      eq,boot     ;Programm beenden
   cp      backf       ;IF zurueckblaettern
   jr      ne,np2      ;THEN
   ld      b,2*pmax+1  ;B  <- Zeilen zurueck
   ld      de,text     ;DE <- Textanfang
np1a:                  ;CYCLE (B)
   dec     hl          ;HL <- ein Zeichen zurueck
   ld      a,l         ;A  <- LowByte Textpointer
   cp      e           ;nicht ueber Textanfang
   jr      ne,np1b     ;hinaus zurueckblaettern
   ld      a,h
   cp      d
   jr      eq,np3
np1b:
   ld      a,(hl)      ;A  <- Zeichen
   cp      LF          ;IF Zeilenende
   jr      ne,np1a     ;THEN
   djnz    np1a        ;Zaehler vermindern
   jr      np3         ;END CYCLE
np2:                   ;ELSE
   cp      forwrdf     ;IF vorwaertsblaettern
   jr      ne,np1
np3:                   ;ENDIF
   call    clear       ;Bildschirmloeschen
   ld      b,0         ;Zeilenzaehler auf 0 setzen
   ret
;
clear:                 ;Bildschirm loeschen
   ld      de,clrscr   ;DE <- Loeschkommando
   call    prstr       ;String ausgeben
   ret
;
prstr:                 ;String ausgeben
   push    bc          ;BC sichern
   push    hl          ;HL sichern
   ld      c,printf    ;C  <- Print String
   call    bdos        ;String ausgeben
   pop     hl          ;HL zurueckladen
   pop     bc          ;BC zurueckladen
   ret
;
clrscr:
   db      ESC,'E',ESC,'H$'
contmsg:
   if      pcw
   db      ESC,'Y',32+30,32+84
   else
   db      ESC,'Y',32+24,32+74
   endif
   db      BELL,ESC,'p'
   db      ' +-0 ',ESC,'q$'
;
   global  text
text:                  ;Beginn Textbereich
   end

